Bug 1400 - mailbox locking does not work on reiserfs
: mailbox locking does not work on reiserfs
Status: CLOSED FIXED
: Sisyphus
(All bugs in Sisyphus/uw-imap)
: unstable
: all Linux
: P3 blocker
Assigned To:
:
:
:
:
:
  Show dependency tree
 
Reported: 2002-10-12 18:22 by
Modified: 2004-06-03 16:56 (History)


Attachments
0001400-lock1-sim.c (5.48 KB, application/octet-stream)
2002-10-15 22:20, Sergey Vlasov
no flags Details


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2002-10-12 18:22:37
In uw-imap-2001a-alt6 (and probably in other versions) mailbox locking with
fcntl() does not work if the mailbox file is on reiserfs - strace does not show
any attempts to lock using fcntl(). However, fcntl() locking works on ext2 and
ext3; I have not tried other filesystems - there may be more such problems.

The problem was observed with kernel24-up-2.4.18-alt8, reiserfs 3.6.

Seems that src/osdep/unix/nfstnew.c:test_nfs() considers that the mailbox is on
a NFS filesystem, therefore fcntl() locking is turned off. This function tries
to perform ustat() on the filesystem and checks usbuf.f_tinode; it happens that
reiserfs returns -1 in this field.
---

---
------- Comment #1 From 2002-10-15 21:50:47 -------
According to my tests, locking works in uw-imap-2001a-alt6 on ext2, ext3, xfs,
jfs and even vfat. Doesn\'t work on reiserfs-3.6. (reiserfs-3.5 test creshed,
so no information yet.)
------- Comment #2 From 2002-10-15 21:50:47 -------
According to my tests, locking works in uw-imap-2001a-alt6 on ext2, ext3, xfs,
jfs and even vfat. Doesn\'t work on reiserfs-3.6. (reiserfs-3.5 test creshed,
so no information yet.)
------- Comment #3 From 2002-10-15 21:52:10 -------
The tests have been done on 2.4.19-alt0.2-up.
------- Comment #4 From 2002-10-15 21:52:10 -------
The tests have been done on 2.4.19-alt0.2-up.
------- Comment #5 From 2002-10-15 22:23:16 -------
I test the locking with help of the simple program (attached; it is very close
to how imapd works): I set different kinds of locks and intermix this with
accessing the box through imapd (trying to modify it).
------- Comment #6 From 2002-10-15 22:23:16 -------
I test the locking with help of the simple program (attached; it is very close
to how imapd works): I set different kinds of locks and intermix this with
accessing the box through imapd (trying to modify it).
------- Comment #7 From 2002-10-15 23:55:08 -------
no locking on reiserfs-3.5 as well (the crash I mentioned was probably caused
by jfs).
------- Comment #8 From 2002-10-15 23:55:08 -------
no locking on reiserfs-3.5 as well (the crash I mentioned was probably caused
by jfs).
------- Comment #9 From 2002-11-02 01:28:48 -------
waiting for the updates for released distros, then will mark it resolved.

Already resolved in uw-imap-2001a-alt8 and pine-4.44L-alt4 in Sisyphus.
------- Comment #10 From 2002-11-02 01:28:48 -------
waiting for the updates for released distros, then will mark it resolved.

Already resolved in uw-imap-2001a-alt8 and pine-4.44L-alt4 in Sisyphus.
------- Comment #11 From 2003-08-25 14:25:44 -------
Should this bug be closed? Master 2.2 contains the fixed version; update for
Master 2.0 was not prepared...
------- Comment #12 From 2004-06-03 16:41:22 -------
как я понял сейчас эта бага уже неактуальна. Нечего плодить в bugzilla 
закрытые блоки. Закрываю. 

------- Comment #13 From 2004-06-03 16:56:30 -------
Да, это исправлено уже очень давно.